//+------------------------------------------------------------------+
//|                                        II_Dynamic_Range_Hist.mq4 |
//|                            Copyright  2010, Insanity Industries |
//|                                http://www.insanityindustries.net |
//| v 1.0 20/11/10
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Insanity Industries"
#property link      "http://www.insanityindustries.net"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_width1 2
#property indicator_color2 RoyalBlue
#property indicator_width2 2
#property indicator_color3 Goldenrod
#property indicator_width3 2

extern int iPeriods = 12;

double MRU[],MRD[],RP[];

string pair,shortname;

int i,tf;
double h,l,point;

datetime barstart;


int init(){
   SetIndexBuffer(0,MRU);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexLabel(0,"MRU "+iPeriods);
   SetIndexBuffer(1,MRD);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexLabel(1,"MRD "+iPeriods);
   SetIndexBuffer(2,RP);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"RP");

   SetLevelValue(0,100);
   SetLevelValue(1,50);
   SetLevelStyle(0,1,Goldenrod);
   SetLevelStyle(1,1,Goldenrod);

   IndicatorShortName("II_Dynamic_Range_Hist "+Symbol()+" "+Period());
   IndicatorDigits(1);

   point=Point;
   if(Digits==3||Digits==5)point*=10;

   pair=Symbol();
   tf=Period();
   return(0);
}

int deinit(){

   return(0);
}

int start(){
   int counted_bars=IndicatorCounted();
   int limit = MathMin(Bars-counted_bars, Bars-(iPeriods+1));

   for(i=limit;i>=0;i--){
      h = High[iHighest(pair,tf,MODE_HIGH,iPeriods,i)];
      l = Low[iLowest(pair,tf,MODE_LOW,iPeriods,i)];
      if(Time[iHighest(pair,tf,MODE_HIGH,iPeriods,i)] > Time[iLowest(pair,tf,MODE_LOW,iPeriods,i)]){
         MRU[i] = (h-l)/point;
         MRD[i] = 0;
         RP[i] = ((Close[i]-l)/(h-l)*100);
      }else{
         MRU[i] = 0;
         MRD[i] = (h-l)/point;
         RP[i] = ((h-Close[i])/(h-l)*100);
      }
   }
   return(0);
}